/*
  2016.06.25 Isabel_01
     copied and adapted from Jonah_04
  2016.06.26 Isabel_02
     tidied up code, and removed all software corrections for poor resistor selections!
  
*/

// defined as const to save memory
const int ModePB = 2;       // Pushbutton input, used to dictate which 'mode' the light flasher should adopt
const int LDR = A0;         // LDR sensor, used to sense the brightness
const int DimmerPot  = A2;  // Potentiometer input, used to adjust the brightness of the LEDs
const int ch1 = 3;         // digital pin for channel 1 leds
const int ch2 = 5;            // digital pin for channel 2 leds
const int ch3 = 6;            // digital pin for channel 3 leds
const int ch4 = 9;            // digital pin for channel 4 leds
const int ch5 = 10;           // digital pin for channel 5 leds
const int ch6 = 11;         // digital pin for channel 6 leds
const int hysterisis = 100;  // difference between 'light'and 'dark' - to avoid flickering at the boundary value
const int Darkness = 400;   // value at which the LDR inout should be perceived to be dark
const int minBrightness = 45;
unsigned long currentTime = 0;
unsigned long autoTimeOff = 7200000; // 2 hours (7,200,000 milli seconds)
int Mode = 1;
int LightValue = 0;
boolean Dark = false;

void setup() {
  // Serial.begin(9600);      // set the baud rate for the serial comms
  pinMode(ch1, OUTPUT);      //set up the various digital I/O as outputs, and drive them low / off - only PWM outputs selected here
  pinMode(ch2, OUTPUT);   //set up the various digital I/O as outputs, and drive them low / off - only PWM outputs selected here
  pinMode(ch3, OUTPUT);    //set up the various digital I/O as outputs, and drive them low / off - only PWM outputs selected here
  pinMode(ch4, OUTPUT);   //set up the various digital I/O as outputs, and drive them low / off - only PWM outputs selected here
  pinMode(ch5, OUTPUT);     //set up the various digital I/O as outputs, and drive them low / off - only PWM outputs selected here
  pinMode(ch6, OUTPUT);    //set up the various digital I/O as outputs, and drive them low / off - only PWM outputs selected here

  digitalWrite(ch1, LOW);
  digitalWrite(ch2, LOW);
  digitalWrite(ch3, LOW);
  digitalWrite(ch4, LOW);
  digitalWrite(ch5, LOW);
  digitalWrite(ch6, LOW);
  pinMode(ModePB, INPUT);   // declare pin 2 as in input, to read the mode selector push button
}

void loop() {


  LightValue = analogRead(LDR); // read the value of the LDR
  if (digitalRead(ModePB)) { // if the switch is on...
    Mode++;   // increament the mode number
    if (Mode > 5) { // if the mode selection reaches its limit, loop back to mode 1
      Mode = 1;
    }
    delay(500); //start with a delay to differentiate from the previous led status
    for (int i = 1; i <= Mode; i++) { // give user feedback to reflect the mode number - all outputs flash a number of times that reflects the mode number
      digitalWrite(ch1, HIGH);
      digitalWrite(ch2, HIGH);
      digitalWrite(ch3, HIGH);
      digitalWrite(ch4, HIGH);
      digitalWrite(ch5, HIGH);
      digitalWrite(ch6, HIGH);
      delay(250);
      digitalWrite(ch1, LOW);
      digitalWrite(ch2, LOW);
      digitalWrite(ch3, LOW);
      digitalWrite(ch4, LOW);
      digitalWrite(ch5, LOW);
      digitalWrite(ch6, LOW);
      delay(250);
    }
  }

  /* comment out the serial print stuff as it slows down the program
    Serial.print("Mode = ");
    Serial.print(Mode);
    Serial.print("ModePB = ");
    Serial.print(digitalRead(ModePB));
    Serial.print("), Dimmer = ");
    Serial.print(map(analogRead(DimmerPot), 0, 1023, 50, 255));
    Serial.print(", Brightness = ");
    Serial.print(LightValue);
    Serial.print(", Dark = ");
    if(Dark){
    Serial.print("TRUE");
    }
    else if (!Dark){
    Serial.print("FALSE");
    }
    Serial.println();              //print out the LDR value, and a carriage return


  */

  if (!Dark && LightValue < Darkness - hysterisis) {   // if dark is not true, and the dimmer is recording a low value...
    Dark = true;                                      //  then set Dark
    currentTime = millis();                           // record the current time
  }
  else if (LightValue > Darkness) {
    Dark = false;
  }

  if (Dark && (millis() - currentTime) < autoTimeOff) {          // only work when it is dark and the max timer has not elapsed
    switch (Mode) {
      case 1:
        Mode1(map(analogRead(DimmerPot), 0, 1023, 30, 255));    // call function Mode1, and pass to it the value of the dimmer potentiometer, scaled in the range 50 to 255
        break;
      case 2:
        Mode2(map(analogRead(DimmerPot), 0, 1023, 30, 255));    // call function Mode1, and pass to it the value of the dimmer potentiometer, scaled in the range 50 to 255
        break;
      case 3:
        Mode3(map(analogRead(DimmerPot), 0, 1023, 30, 255));                // call function Mode3
        break;
      case 4:
        Mode4();                // call function Mode4
        break;
      case 5:
        Mode5(map(analogRead(DimmerPot), 0, 1023, 30, 255));     // call function Mode5, and pass to it the value of the dimmer potentiometer, scaled in the range 50 to 255
        break;
    }
  }
  else if (!Dark || (millis() - currentTime) > autoTimeOff) {                  // It's not dark, or the maximum timer has elapsed, switch off all output
    digitalWrite(ch1, LOW);
    digitalWrite(ch2, LOW);
    digitalWrite(ch3, LOW);
    digitalWrite(ch4, LOW);
    digitalWrite(ch5, LOW);
    digitalWrite(ch6, LOW);
    delay(300);
  }
  delay(1); // build in a small delay, otherwise the Analog/Digital conversion may perform erratically
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Mode1 - randomly change the light output of each of the circuits, but fade to the new targets
void Mode1(int brightness) {   // return noting, but take as input the dimmer value into a parameter called brightness

  int target[6] = {
    0, 0, 0, 0, 0, 0
  }; // set an array to store the target values
  int current[6] = {
    0, 0, 0, 0, 0.0
  }; // set an array to store the current values

  while (Dark && (millis() - currentTime) < autoTimeOff && !digitalRead(ModePB)) { // continue for as long as it's dark, the mode pushbutton has not been pressed, and it's not timed out
    for (int i = 0; i < 6; i++) {    // for all values in the array
      if (current[i] == target[i]) { // if the current value has reached the target...
        target[i] = random(max(minBrightness, (brightness - 100)), min((brightness + 75), 255)); // ...set a new target for ch[i]        
      }
      if (current[i] > target[i]) { // if the current value for i is higher than the target...
        current[i] --;               // decrement the value
      }
      else {                        // if the current value for i is lower than the target...
        current[i] ++;             // increment the value
      }
    }
    analogWrite(ch1, current[0]);
    analogWrite(ch2, current[1]);
    analogWrite(ch3, current[2]);
    analogWrite(ch4, current[3]);
    analogWrite(ch5, current[4]);
    analogWrite(ch6, current[5]);
    delay(30);
    LightValue = analogRead(LDR); // read the value of the LDR
    if (LightValue > Darkness) {
      Dark = false;
    }
  } //end while
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Mode2 - randomly change the light output of each of the circuits
void Mode2(int brightness) {   // return noting, but take as input the dimmer value into a parameter called brightness
  // set the led to a ramdom value, around the target brightness setting, but don't allow values below the minimum or above the maximum
  analogWrite(ch1, (random(min(minBrightness, (brightness - 75)), min((brightness + 75), 255))));
  analogWrite(ch2, (random(max(minBrightness, (brightness - 75)), min((brightness + 75), 255))));
  analogWrite(ch3, (random(max(minBrightness, (brightness - 75)), min((brightness + 75), 255))));
  analogWrite(ch4, (random(max(minBrightness, (brightness - 75)), min((brightness + 75), 255))));
  analogWrite(ch5, (random(max(minBrightness, (brightness - 75)), min((brightness + 75), 255)))); //allow the green leds to be a little brighter than the others, as they are generally dimmer
  analogWrite(ch6, (random(min(minBrightness, (brightness - 75)), min((brightness + 75), 255))));
  delay(1000);
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


void Mode3(int brightness) {
  analogWrite(ch1, constrain(brightness - 75, minBrightness, 255));
  delay (150);
  digitalWrite(ch1, LOW);
  analogWrite(ch2, constrain(brightness - 75, minBrightness, 255));
  delay(150);
  digitalWrite(ch2, LOW);
  analogWrite(ch3, constrain(brightness + 75, minBrightness, 255));
  delay(150);
  digitalWrite(ch3, LOW);
  analogWrite(ch4, constrain(brightness - 75, minBrightness, 255));
  delay(150);
  digitalWrite(ch4, LOW);
  analogWrite(ch5, constrain(brightness - 75, minBrightness, 255));
  delay(150);
  digitalWrite(ch5, LOW);
  analogWrite(ch6, constrain(brightness - 75, minBrightness, 255));
  delay(150);
  analogWrite(ch1, constrain(brightness - 75, minBrightness, 255));
  analogWrite(ch2, constrain(brightness - 75, minBrightness, 255));
  analogWrite(ch3, constrain(brightness - 75, minBrightness, 255));
  analogWrite(ch4, constrain(brightness - 75, minBrightness, 255));
  analogWrite(ch5, constrain(brightness - 75, minBrightness, 255));
  delay (10000);
  digitalWrite(ch1, LOW);
  delay(50);
  digitalWrite(ch2, LOW);
  delay(50);
  digitalWrite(ch3, LOW);
  delay(50);
  digitalWrite(ch4, LOW);
  delay(50);
  digitalWrite(ch5, LOW);
  delay(50);
  digitalWrite(ch6, LOW);
  delay(1000);
}



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


void Mode4() {

  int brightness = 15;    // how bright the LED is
  int fadeAmount = 1;    // how many points to fade the LED by

// problems with below while loop - added the analogRead(LDR) to exit the loop if it becomes bright. Also need to have a max-timeout clause here

  while (analogRead(LDR) < Darkness && (millis() - currentTime) < autoTimeOff && !digitalRead(ModePB)) { // this while loop can take a while, so allow the mode PB to exit the loop if it is pressed
    analogWrite(ch1, brightness);
    analogWrite(ch2, brightness);
    analogWrite(ch3, brightness);
    analogWrite(ch4, brightness);
    analogWrite(ch5, brightness);
    analogWrite(ch6, brightness);
    brightness = brightness + fadeAmount;   // change the brightness for next time through the loop:
    if (brightness == 15 || brightness == 255) {
      fadeAmount = -fadeAmount ;   // reverse the direction of the fading at the ends of the fade:
    }
    delay(30);                        // wait for 30 milliseconds to see the dimming effect
  }
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


void Mode5(int brightness) {
  analogWrite(ch1, constrain(brightness, minBrightness, 255));
  analogWrite(ch2, constrain(brightness, minBrightness, 255));
  analogWrite(ch3, constrain(brightness, minBrightness, 255));
  analogWrite(ch4, constrain(brightness, minBrightness, 255));
  analogWrite(ch5, constrain(brightness, minBrightness, 255));
  analogWrite(ch6, constrain(brightness, minBrightness, 255));
  delay(1000);
}


