/* Three PWM Outputs */

// ATtiny85 outputs
const int Channel1 = 0; // pin 5 on ATTiny85
const int Channel2 = 1; // pin 6 on ATTiny85
const int Channel3 = 4; // pin 3 on ATTiny85
const int Dimmer = A3;  // pin 2 on ATTiny85
const int LDR = A1;     // pin 7 on ATTiny85

volatile uint8_t* Port[] = {&OCR0A, &OCR0B, &OCR1B}; // from http://www.technoblogy.com/show?LE0


void setup() {
  pinMode(Channel1, OUTPUT);
  pinMode(Channel2, OUTPUT);
  pinMode(Channel3, OUTPUT);
  pinMode(Dimmer, INPUT);
  pinMode(LDR, INPUT);


// The following section relates to adding PWM capability on more than two pins on the ATTiny85, derived from http://www.technoblogy.com/show?LE0
  // Configure counter/timer0 for fast PWM on PB0 and PB1 (Pins 5 & 6 respectively)
  TCCR0A = 3<<COM0A0 | 3<<COM0B0 | 3<<WGM00;
  TCCR0B = 0<<WGM02 | 3<<CS00; // Optional; already set
  // Configure counter/timer1 for fast PWM on PB4 (Pin 3)
  GTCCR = 1<<PWM1B | 3<<COM1B0;
  TCCR1 = 3<<COM1A0 | 7<<CS10;
}



// Sets colour Red=0 Green=1 Blue=2 to specified intensity 0 (off) to 255 (max)
void SetColour (int colour, int intensity) {
  *Port[colour] = 255 - intensity;
}

void loop() {
  for (int colour=0; colour<3; colour++) {
    SetColour((colour+2) % 3, 0);
    for (int i=0; i <= 255; i++) {
      SetColour((colour+1) % 3, i);
      SetColour(colour, 255-i);
      delay(25);
    }
  }
}








