// ATtiny85 outputs
const int channel1 = 0; // pin 5 on ATTiny85
const int channel2 = 1; // pin 6 on ATTiny85
const int channel3 = 4; // pin 3 on ATTiny85
const int dimmerPot = A3;  // pin 2 on ATTiny85
const int LDR = A1;     // pin 7 on ATTiny85

int minBrightness = 20; //minimum allowable brightness
const int hysterisis = 100;  // difference between 'light'and 'dark' - to avoid flickering at the boundary value
const int Darkness = 400;   // value at which the LDR inout should be perceived to be dark

       int brightness = 255; // temp parameter to feed the test function

unsigned long currentTime = 0;
unsigned long autoTimeOff = 7200000; // 2 hours (7,200,000 milli seconds)
int Mode = 1;
int LightValue = 0;
boolean Dark = false;

  int target[3] = {0, 0, 0 }; // set an array to store the target values
  int current[3] = { 0, 0, 0 }; // set an array to store the current values


volatile uint8_t* Port[] = {&OCR0A, &OCR0B, &OCR1B}; // from http://www.technoblogy.com/show?LE0, these are the PWM timers attached to pins 5, 6 & 2 respectively


void setup() {
  pinMode(Channel1, OUTPUT);
  pinMode(Channel2, OUTPUT);
  pinMode(Channel3, OUTPUT);
  pinMode(Dimmer, INPUT);
  pinMode(LDR, INPUT);


// The following section relates to adding PWM capability on more than two pins on the ATTiny85, derived from http://www.technoblogy.com/show?LE0
  // Configure counter/timer0 for fast PWM on PB0 and PB1 (Pins 5 & 6 respectively)
  TCCR0A = 3<<COM0A0 | 3<<COM0B0 | 3<<WGM00;
  TCCR0B = 0<<WGM02 | 3<<CS00; // Optional; already set
  // Configure counter/timer1 for fast PWM on PB4 (Pin 3)
  GTCCR = 1<<PWM1B | 3<<COM1B0;
  TCCR1 = 3<<COM1A0 | 7<<CS10;
}



// Sets colour Red=0 Green=1 Blue=2 to specified intensity 0 (off) to 255 (max)
/*
void SetColour (int colour, int intensity) {
  *Port[colour] = 255 - intensity;
}
*/

void loop() {


	LightValue = analogRead(LDR); // read the value of the LDR

  if (!Dark && LightValue < Darkness - hysterisis) {   // if dark is not true, and the dimmer is recording a low value...
    Dark = true;                                      //  then set Dark
    currentTime = millis();                           // record the current time
  }
  else if (LightValue > Darkness) {									// if the LDR doesn't record low light...
    Dark = false;																		// then it's not dark!
  }

  if (Dark && (millis() - currentTime) < autoTimeOff) {			// if it's dark, and we're within the maximum time that the LEDs will work for each night

// do something here - perhaps call a function to manage the leds

}

 else if (!Dark || (millis() - currentTime) > autoTimeOff) {                  // It's not dark, or the maximum timer has elapsed, switch off all output
    digitalWrite(channel1, LOW);
    digitalWrite(channel2, LOW);
    digitalWrite(channel3, LOW);
    delay(300);
  }
  delay(1); // build in a small delay, otherwise the Analog/Digital conversion may perform erratically
}



  while (Dark && (millis() - currentTime) < autoTimeOff) {
      for (int i = 0; i < 3; i++) {    // for all values in the array
	      if (current[i] == target[i]) { // if the current value has reached the target...
  	      target[i] = random(0, 255); // ...set a new target for ch[i]        
    	  }
 	     if (current[i] > target[i]) { // if the current value for i is higher than the target...
  	      current[i] --;               // decrement the value
    	  }
  	    else {                        // if the current value for i is lower than the target...
    	    current[i] ++;             // increment the value
      	}
      }
  
      *Port[0] = 255 - current[0];
            *Port[1] = 255 - current[1];
                  *Port[2] = 255 - current[2];

    delay(30);
  


}




